"use strict";

module.exports = {
  list: function list() {
    this.playlist.forEach(function (ele) {
      return console.log(ele.src.split('/').slice(-1)[0], ele);
    });
  },
  getFile: function getFile(link) {
    return link.split('/').slice(-1);
  },
  getHost: function getHost(link) {
    return link.split('/').filter(function (p) {
      return p && !p.includes('http');
    })[0];
  },
  log: function log() {
    var _this = this;

    if (this.logger) clearInterval(this.logger);else {
      this.logger = setInterval(function () {
        var activeRepeat = _this.repeatEach ? 'Each' : _this.repeatWhole ? 'Whole' : _this.repeatForever ? 'Forever' : 'Standard';
        console.clear();

        _this.playlist.forEach(function (e) {
          return console.log("File: ".concat(_this.getFile(e.src), " | Host: ").concat(_this.getHost(e.src), " | Playing: ") + "".concat(_this.isActive(e), " | Seconds: ").concat(e.duration.toFixed(2), "/").concat(e.currentTime.toFixed(2)));
        });

        console.log("[Repeats: ".concat(activeRepeat, "]   [Delay Seconds: ").concat((_this.repeatDelay / 1000).toFixed(2), "]") + "   [Paused: ".concat(_this.isPaused(), "]   [Muted: ").concat(_this.isMuted(), "]"));
      }, this.isFirefox() ? 100 : 1000);
    }
  }
};