"use strict";

module.exports = {
  choice: function choice() {
    var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var nextIndex = Math.floor(Math.random() * array.length);
    return {
      nextIndex: nextIndex,
      nextItem: array[nextIndex]
    };
  },
  keepWithin: function keepWithin() {
    var index = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 0;
    var array = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var nextIndex = index.toString().includes('-') ? array.length ? array.length - 1 : 0 : index > array.length - 1 ? 0 : index;
    return {
      nextIndex: nextIndex,
      nextItem: array[nextIndex]
    };
  },
  findFile: function findFile() {
    var file = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
    return this.playlist[this.playlist.map(function (ele) {
      return ele.src;
    }).indexOf(file)];
  },
  addPromise: function addPromise() {
    var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Function;
    var pre = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    var promise = new Promise(function (resolve) {
      return callback(resolve);
    });
    this[pre ? 'prePromises' : 'postPromises'].push(promise);
  },
  waitForDOM: function waitForDOM() {
    var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Function;
    return document.readyState === 'complete' ? callback() : window.addEventListener('DOMContentLoaded', function () {
      return callback();
    });
  },
  handleAutoPlayNotAllowed: function handleAutoPlayNotAllowed() {
    var _this = this;

    var audio = document.createElement('audio');
    audio.src = this.silence;
    var promise = audio.play();
    promise && promise["catch"] && promise["catch"](function (error) {
      return !_this.isAutoPlayEnabled(error) && _this.createOverlayInstructions();
    });
  },
  isFirefox: function isFirefox() {
    return !this.isChrome() && window.navigator.userAgent.includes('Firefox');
  },
  isEdge: function isEdge() {
    return !this.isChrome() && window.navigator.userAgent.includes('Edge');
  },
  isOpera: function isOpera() {
    return !this.isChrome() && window.navigator.userAgent.includes('OPR');
  },
  isSafari: function isSafari() {
    return !this.isOpera() && !this.isChrome() && window.navigator.userAgent.includes('Safari');
  },
  isChrome: function isChrome() {
    return window.navigator.vendor === 'Google Inc.' && window.navigator.userAgent.includes('Chrome') && !window.navigator.userAgent.includes('OPR');
  },
  isAutoPlayEnabled: function isAutoPlayEnabled(error) {
    return !(error.name === 'NotAllowedError');
  }
};